
/*  xphotohunter v1.4
 *  AUTHOR: Jian-min Chen (ض{)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#define VERSION " 1.4"
#define PACKAGE  "xphotohunter"
#define _(String) gettext(String)

//------------------------------------------
#define TITLE_S      _("XPhotoHunter ")
#define START_S      _("Start")
#define RANK_S       _("Rank")
#define ABOUT_S      _("About")
#define EXIT_S       _("Exit")
#define GRADE_S      _("Grade")
#define TIME_S       _("Time")
#define ENERGY_S     _("Energy")
#define SCORE_S      _(" \nScore")                              // MUST has a space before \n
#define GIVEUP_S     _("Give up")
#define TOTAL_S      _("Total\nPictures")
#define PASS_S       _("\nYou got it !")
#define OVER_S       _("\nYour energy is over.\nTry again !")
#define PASS_ALL_S   _("\nYeah!\nYou have pass all pictures !!\n ")    // Must has a space after \n
#define PASS_WRONG_S _("\nYou have passed all pictures,\nbut you gave up some pictures.\nTry more!")
#define BUTTON_OK_S  _("Ok")
#define INPUT_S      _("You got a high score !!\nEnter your name & words.")
#define RANK_T       _("Rank")
#define NAME_T       _("Name")
#define WORD_T       _("Victory Announcement")
#define SCORE_T      _("Score")
#define GRADE_T      _("Grade")

#define ERROR1_S     _("Error: the directory doesn't exist:")
#define ERROR2_S     _("You can set the environment variable :")
#define ERROR3_S     _("Remember to 'export' the variable.")
#define NO_PIC_S     _("No Picture Available.\nExit..\n")
#define NO_PLAYER_S   _("Can't execute esdplay or wavplay")
//--------------------------------------------

#ifndef DATA_DIR
#define DATA_DIR "/usr/local/share/xphotohunter"
#endif

#define DIR_ENVIRON "XPHOTOHUNTER"                              // MUST "export"
#define RC_FILENAME "xphotohunter.rc"
#define RANK_FILE "xphotohunter.dat"
#define RANK_FILE_MODE 0666

#define LOCALE_DIR "locale/"                          // dir string ended with '/'
#define LICENSE_FILE "License.txt"
#define RULE_FILE "Rule.txt"

#define ESDPLAY "esdplay"
#define WAVPLAY "wavplay"
#define RIGHT_WAV "Yes.wav"
#define WRONG_WAV "Ouch.wav"
#define OVER_WAV "Cackle.wav"
#define PASS_ALL_WAV "Good.wav"

#define PRE_PIX_FILE "XPhotoHunter.bmp"
#define ABOUT_PIX_FILE "About_pic.jpg"
#define LAMP_FILENAME "lamp.xpm"
//#define LAMP_MASK_FILENAME "lamp_mask.xpm"
#define LAMP_SIZE 20                                            // pixels

#define START_B_PIX "start.jpg"
#define RANK_B_PIX "rank.jpg"
#define ABOUT_B_PIX "about.jpg"
#define EXIT_B_PIX "exit.jpg"
#define GIVEUP_B_PIX "giveup.jpg"

#define PICTURE_DIR "Picture/"                          // dir string ended with '/'
#define PICTURE_FILE_POST "jpg"
#define MAX_PIX 300
#define APPEND_LEN 3

#define DATA_FILE_POST "ppp"
#define DIFF_NUM 5
#define LEFT_INDEX 0
#define UP_INDEX 1
#define RIGHT_INDEX 2
#define DOWN_INDEX 3

#define TIME_AVAIL 95                                           // seconds
#define TIME_GIVEUP_LOSS 5                                      // seconds
#define ENERGY_TIME_DELAY 5                             // seconds
#define ENERGY_TIME_LOSS 0.1                            // 0~1
#define ENERGY_GIVEUP_LOSS 0.1                          // 0~1
#define ENERGY_POINT_LOSS 0.1                           // 0~1

//#define PROGRESSBAR_COLOR "blue"
#define ARC_COLOR "#ff4444"
#define ARC_WIDTH 3
#define CHECK_TIME_INTERVAL 400                         // milliseconds

#define RANK_NUM 10
#define NAME_LEN 20
#define WORD_LEN 80
