
/*  xphotohunter v1.4
 *  AUTHOR: Jian-min Chen (ض{)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/* New Function
makefile                y
config.h                y
readme                  y
license                 y
English (text)		y
text font16
about                   y
score high              y
pass_all                y
midi
midi select
entry                   y
tooltips
shape
rank board                   y
answer
all picture number          y
icon                    y
array malloc
gtk-grab-focus
gtk-1.2                         y
gettext locale            y
readv writev
environ variable XPHOTOHUNTER       y
*/
/* Bugs
overlap                 y
malloc rand_pix         y
label overflow          y
path                    y
pixmap memory save        y
xphotohunter.dat 666    y
dialog destroy event	y
timeout & over		y
text -locale
wavplay 
*/

/*
Change from Gtk-1.0.x to Gtk-1.2.x
1. Makefile:
    LIBS=-lgdk_imlib -ljpeg -ltiff -lpng -lz -lgif  `gtk-config --libs` -lXi -lXext -lX11 -lm
    INCLUDES=`gtk-config --cflags`
2. handle.c:
    Gtk-1.2.x doesn't support gtk_clist_set_policy (GTK_CLIST(rank_clist),
              GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
3. handle.c
    From gtk_clist_set_border(GTK_CLIST(rank_clist), GTK_SHADOW_IN);
    to gtk_clist_set_shadow_type(GTK_CLIST(rank_clist), GTK_SHADOW_IN);
4. handle.c
    gtk_clist_append(GTK_CLIST(rank_clist), string2);
5. main.h
    #include <stdio.h>

*/

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <gdk_imlib.h>
#include <libintl.h>                    // gettext
#include <locale.h>                     //gettext
#include <dirent.h>
#include <time.h>
#include <sys/types.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>                     // sleep() ...
#include <sys/wait.h>                   // wait()
#include <sys/stat.h>                   // fchmod()
#include "config.h"

#define DIM_LEN  30
#define ARC_MULTI 64

enum status_type
{
   NOTHING, PLAYING, DIALOG, RANK, ABOUT
} status;

struct rank_struct
{
   gint rank;
   gint score;
   gchar name[NAME_LEN];
   gchar word[WORD_LEN];
   gint grade;
} rank_record[RANK_NUM];

gint grade, time_num, time_total, score, pass_num, rank_num, insert_num;
gboolean if_fork, if_rank;
gint pre_pix_w, pre_pix_h, about_pix_w, about_pix_h, pix1_w, pix1_h, pix2_w, pix2_h;
gint point_signal_id1, point_signal_id2, timeout_tag;
gint about_signal_id, rank_signal_id;
gfloat energy;
gchar grade_s[DIM_LEN], time_s[DIM_LEN], score_s[DIM_LEN], total_s[DIM_LEN];
gchar locale_s[30], data_dir[100], pix_pre_filename[MAX_PIX][100];
gint found, rand_len, rand_index;
gint *rand_pix, answer[DIFF_NUM][4], already_right[DIFF_NUM];
time_t start_time, last_time;

  GtkWidget *window1;
  GtkWidget *vpane;
  GtkWidget *fixed1;
  GtkWidget *start_b;
  GtkWidget *rank_b;
  GtkWidget *about_b;
  GtkWidget *exit_b;
  GtkWidget *progressbar;
  GtkWidget *giveup_b;
  GtkWidget *fixed_1;
  GtkWidget *fixed_2;
  GtkWidget *vseparator1;
  GtkWidget *time_num_t;
  GtkWidget *time_l;
  GtkWidget *grade_num_t;
  GtkWidget *grade_l;
  GtkWidget *energy_l;
  GtkWidget *score_num_t;
  GtkWidget *score_l;
  GtkWidget *total_num_t;
  GtkWidget *total_l;

  GtkWidget *start_b_box;
  GtkWidget *start_b_pixmap;
  GtkWidget *start_b_label;
  GtkWidget *rank_b_box;
  GtkWidget *rank_b_pixmap;
  GtkWidget *rank_b_label;
  GtkWidget *about_b_box;
  GtkWidget *about_b_pixmap;
  GtkWidget *about_b_label;
  GtkWidget *exit_b_box;
  GtkWidget *exit_b_pixmap;
  GtkWidget *exit_b_label;
  GtkWidget *giveup_b_box;
  GtkWidget *giveup_b_pixmap;
  GtkWidget *giveup_b_label;

  GtkWidget *hbox;
  GtkWidget *hpane;
  GtkWidget *event_box1;
  GtkWidget *event_box2;
  GtkWidget *lamp_p[DIFF_NUM];
  GtkWidget *pix_p1;
  GtkWidget *pix_p2;

  GtkWidget *rank_table;
  GtkWidget *rank_clist;
  GtkWidget *rank_ok;

  GtkWidget *table1;
  GtkWidget *frame;
  GtkWidget *pre_p;
  GtkWidget *about_ok;
  GtkWidget *table2;
  GtkWidget *text_w;
  GtkWidget *vscroll;
//  GtkWidget *hscroll;

  GtkWidget *dialog;
  GtkWidget *dialog_table;
  GtkWidget *dialog_message;
  GtkWidget *dialog_ok;
  GtkWidget *dialog_separator;
  GtkWidget *dialog_input_l;
  GtkWidget *dialog_name_l;
  GtkWidget *dialog_name_t;
  GtkWidget *dialog_word_l;
  GtkWidget *dialog_word_t;

  GdkPixmap *pre_pix, *about_pix, *lamp, *pix1, *pix2;
  GdkBitmap *pre_pix_mask, *about_pix_mask, *lamp_mask, *pix1_mask, *pix2_mask;
  GtkStyle *style;
  GdkGC *gc;
  GdkColormap *colormap;
  GdkColor color;                               // not a pointer


